import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world in which BeatUp is played.
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */

public class BeatUpWorld  extends World
{
    public Counter scoreboard;
    
    // include directory name for running in Eclipse, too.
    private static final String SOUND_FILE = "sounds/01.wav";
    
    public Comment comment;
    
    Up up = new Up();
    Left left = new Left();
    Right right = new Right();
    Down down = new Down();
    Manager manager = new Manager();
    boolean hasNotStarted = true;
   
    /**
     * Constructor for objects of class BeatUpWorld.
     */
    public BeatUpWorld()
    {    
        super(1000, 600 , 1);
        // show welcome screen
        setBackground("images/bg.png");
    }

    /**
     * Start the game.
     */
	public void act() {

		// start the game when mouse or any key is pressed
		if (hasNotStarted) {
			MouseInfo mouse = Greenfoot.getMouseInfo();
			if (mouse != null && mouse.getButton() == 1) {
					populate();
					hasNotStarted = false;
			}
			if (Greenfoot.getKey() != null ) {
				populate();
				hasNotStarted = false;
			}
		}
	}
    
	/*
	 * add objects to the world.
	 */
    public void populate() {
        Greenfoot.setSpeed(47);
        setBackground("images/back1.jpg");
        scoreboard = new Counter("Score: ");
        comment = new Comment(2);
        
        addObject(scoreboard, 160, 30);
        addObject(up, 500, 120);
        addObject(down, 500, 480);
        addObject(left, 140, 300);
        addObject(right, 860, 300);
        addObject(manager, 0, 0);
        addObject(comment, 800, 50);
		addObject(new D2(), 943, 145);
		addObject(new D3(), 92, 116);
		addObject(new D1(), 272, 492);
        
        playSound();
    }
    
    /**
     * Play music if available, but don't throw esception
     * if music file is not found.
     */
    private void playSound() {
    	try {
    		Greenfoot.playSound( SOUND_FILE );
    	} catch( IllegalArgumentException e ) {
    		// sound file not found. Ignore it.
    	}
    }
}
