import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Black Dot is a diversion.  User should not try to hit it with key press.
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */
public class BlackDot extends Dots
{
    int direction;
    public BlackDot(int direction) {
       this.direction = direction;
    }
    
    public void act() 
    {
        try
        {
            action();
        } catch(Exception e) { }
    }
    
    public synchronized void action() {
        
        if (direction == 0) moveUp();
        else if (direction == 1) moveRight();
        else if (direction == 2) moveDown();
        else if (direction == 3) moveLeft();
    
        // check for a key press while this dot is over an Arrow icon
        if ( killed() ) return; // dot already killed
        
        BeatUpWorld world = (BeatUpWorld)getWorld();
        
		// process keypress - see if key was pressed while we were on an Arrow
        int score = 0;
        
		if (Greenfoot.isKeyDown("up")) score = getHit(Up.class);
		else if (Greenfoot.isKeyDown("left")) score = getHit(Left.class);
		else if (Greenfoot.isKeyDown("right")) score = getHit(Right.class);
		else if (Greenfoot.isKeyDown("down")) score = getHit(Down.class);
		
		// if user pressed key with black dot is within NORMAL distance of arrow icon,
		// then deduct points.
		if ( score >= NORMAL ) {
			world.scoreboard.subtract(100);
			kill();
		}
    }
}
