import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Blue Dot moves in a straight line.
 * User gets points if he presses an arrow key while dot is over a matching Arrow icon.
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */
public class BlueDot  extends Dots
{
	// direction of movement
    private int direction;
    
    public BlueDot(int direction) {
       this.direction = direction;
    }
    
    public void act() 
    {
        try {
            action();
        } catch (Exception e) {}
    }
    
    public synchronized void action() {
		if (atWorldEdge1()) {
			((BeatUpWorld) getWorld()).scoreboard.add(Dots.MISS);
			((BeatUpWorld) getWorld()).comment.setComment(Dots.MISS);
		}
        // move the dot
        if (direction == 0) moveUp();
        else if (direction == 1) moveRight();
        else if (direction == 2) moveDown();
        else if (direction == 3) moveLeft();
        
        if ( killed() ) return; // dot killed already
        
        BeatUpWorld world = (BeatUpWorld)getWorld();
        
		// process keypress - see if key was pressed while we were on an Arrow
        int score = 0;
        
		if (Greenfoot.isKeyDown("up")) score = getHit( Up.class );
		else if (Greenfoot.isKeyDown("left")) score = getHit( Left.class );
		else if (Greenfoot.isKeyDown("right")) score = getHit( Right.class );
		else if (Greenfoot.isKeyDown("down")) score = getHit( Down.class );
		// if score != 0 it means a key was pressed while the dot was over
		// a matching Arrow icon.  Award points and remove the dot from world.
		if ( score != 0 ) {
			world.scoreboard.add(score);
			world.comment.setComment(score);
			kill();
		}
    }
}
