import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Display an comment image, such as "Perfect", "Cool", "Bad".
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */
public class Comment extends Actor {

    // Added "images/..." to filenames to run scenario in Eclipse.
    // It does not have any effect when running in Greenfoot.
    private static GreenfootImage perfectimg=new GreenfootImage("images/perfect.png");
    private static GreenfootImage coolimg=new GreenfootImage("images/cool.png");
    private static GreenfootImage normalimg=new GreenfootImage("images/normal.png");
    private static GreenfootImage badimg=new GreenfootImage("images/bad.png");
    private static GreenfootImage missimg=new GreenfootImage("images/miss.png");

    /** index for image. See updateImage() for values. */
    private int index;
    
    /** Create a new Comment. */
    public Comment(int commentIndex) {
       index = commentIndex;
       updateImage(index);
    }
    
    public void act() {
        // don't do anything
    }
    
    /**
     * Change the comment image.
     * @param commentIndex is the index of the comment to display.
     */
    public void setComment(int commentIndex) {
        if ( commentIndex != index ) updateImage(commentIndex);
    }
    
    private void updateImage(int index)
    {
        switch( index ) {
        case Dots.PERFECT:
           setImage(perfectimg);
           break;
        case Dots.COOL:
           setImage(coolimg);
           break;
        case Dots.NORMAL:
           setImage(normalimg);
           break;
        case Dots.BAD:
           setImage(badimg);
           break;
        case Dots.MISS:
            setImage(missimg);
            break;
        default:
           // error: unknown image index
           return;
        }
        // set attribute to current image index
        this.index = index;
    }    
}
