import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * The Manger creates and fires dots.
 * It keeps track of how many red, blue, and black dots have been fired.
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */
public class Manager extends Actor
{
	// how much to delay between launching 2 dots.
	private static final int MIN_DELAY = 5;
	// how much to delay between launching 2 dots of the same color?
	private static final int MIN_DELAY_SAME_COLOR = 10;
	
	// timers for inter-dot launch times
	int dottimer = 0;
	// timers for delay between launch two dots of same color
	int redtimer = 0;
	int bluetimer = 0;
	int blacktimer = 0;
	
	// center of the world
	int xcenter = 100;
	int ycenter = 100;

	protected void addedToWorld(World world) {
		super.addedToWorld(world);
		int cellsize = world.getCellSize();
		int height = cellsize * world.getHeight();
		int width = cellsize * world.getWidth();
		// center of the world
		xcenter = width/2;
		ycenter = height/2;
	}


	/**
     * Act - do whatever the Manger wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */    
	public void act() {

		dottimer--;
		redtimer--;
		bluetimer--;
		blacktimer--;

		if ( dottimer > 0 ) return;
		
		Dots dot = null;
		if (Greenfoot.getRandomNumber(1000) > 980 && bluetimer <= 0) {
			int direction = Greenfoot.getRandomNumber(4);
			dot = new BlueDot(direction);
			getWorld().addObject(dot, xcenter, ycenter);
			dottimer = MIN_DELAY;
			bluetimer = MIN_DELAY_SAME_COLOR;
		} 
		else if (Greenfoot.getRandomNumber(1000) > 985  && redtimer <= 0) {
			int direction = Greenfoot.getRandomNumber(4);
			dot = new RedDot(direction);
			getWorld().addObject(dot, xcenter, ycenter);
			dottimer = MIN_DELAY;
			redtimer = MIN_DELAY_SAME_COLOR;
		} 
		else if (Greenfoot.getRandomNumber(1000) > 988 && blacktimer <= 0) {
			int direction = Greenfoot.getRandomNumber(4);
			dot = new BlackDot(direction);
			getWorld().addObject(dot, xcenter, ycenter);
			dottimer = MIN_DELAY;
			blacktimer = MIN_DELAY_SAME_COLOR;
		}
	}

}
