import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Red Dot that moves in a straight line.
 * User gets points for pressing OPPOSITE arrow key when dot is over an arrow icon.
 * 
 * @author Athiwat Chunlakhan - Tun
 * @author Wairung Teeranalinvit - Ton
 * @author Soratouch Pronmaneerattanatri - MuDang
 * @version 2010.06.01
 */
public class RedDot extends Dots
{
    // direction of movement
    private int direction;
    
    public RedDot(int direction) {
       this.direction = direction;
    }
    
    /** move the dot and handle key press */
    public void act() 
    {
        try {
            action();
        } catch(Exception e){ }
    }
    
    public synchronized void action() {
        if(atWorldEdge1()) {
            ((BeatUpWorld) getWorld()).scoreboard.subtract(Dots.MISS);
            ((BeatUpWorld) getWorld()).comment.setComment(Dots.MISS);
        }
        // move the dot
        if (direction == 0) moveUp();
        else if (direction == 1) moveRight();
        else if (direction == 2) moveDown();
        else if (direction == 3) moveLeft();
        
        // if already killed, don't check for hit by keypress
        if ( killed() ) return;
        
        BeatUpWorld world = (BeatUpWorld)getWorld();
        
        // assign points for key press
        int score = 0;
        
        // for Red dot, you have to press the opposite key
		if (Greenfoot.isKeyDown("up")) score = getHit( Down.class );
		else if (Greenfoot.isKeyDown("left")) score = getHit( Right.class );
		else if (Greenfoot.isKeyDown("right")) score = getHit( Left.class );
		else if (Greenfoot.isKeyDown("down")) score = getHit( Up.class );
		if ( score != 0 ) {
			// award 2*score for perfect hit
			if ( score >= PERFECT ) world.scoreboard.add(2*score);
			else world.scoreboard.add(score); // any other score as usual
			world.comment.setComment(score);
			kill();
		}
    }
}
